package com.tidefactions.chat.Commands;

import com.tidefactions.chat.Messages;
import com.tidefactions.chat.Types.ChatMode;
import com.tidefactions.chat.Utils.ChatUtils;
import org.apache.commons.lang.StringUtils;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class CommandStaffChat implements CommandExecutor {

    @Override
    public boolean onCommand(CommandSender sender, Command command, String s, String[] args) {
        if (sender.hasPermission(ChatMode.STAFF.getPermission())) {
            if (args.length >= 1) {
                if (sender instanceof Player) {
                    ChatUtils.sendMessageInChannel(
                            ((Player) sender),
                            ChatMode.STAFF,
                            StringUtils.join(args, " "),
                            "Command");
                } else {
                    ChatUtils.sendMessageInChannelAsConsole(
                            ChatMode.STAFF,
                            StringUtils.join(args, " "),
                            "Command");
                }
            } else {
                if (sender instanceof Player) {
                    if (ChatUtils.getChatMode(((Player) sender)) == ChatMode.STAFF) {
                        ChatUtils.setChatMode(((Player) sender), ChatMode.PUBLIC);
                        sender.sendMessage(Messages.PREFIX + Messages.SC_TOGGLE_OFF);
                    } else {
                        ChatUtils.setChatMode(((Player) sender), ChatMode.STAFF);
                        sender.sendMessage(Messages.PREFIX + Messages.SC_TOGGLE_ON);
                    }
                } else {
                    sender.sendMessage(Messages.PREFIX + Messages.SC_CONSOLE);
                }
            }
        } else {
            sender.sendMessage(Messages.PREFIX + Messages.NO_PERMISSION);
        }
        return true;
    }
}
