package com.tidefactions.chat;

import org.bukkit.configuration.InvalidConfigurationException;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;

import static com.tidefactions.chat.Main.colorCodes;

public class Config {
    // Chat formats
    public static String GLOBAL_CHAT_FORMAT;
    public static String STAFF_CHAT_FORMAT;
    public static String ADMIN_CHAT_FORMAT;
    public static String BUILDER_CHAT_FORMAT;

    // Console chat settings
    public static String CONSOLE_PREFIX;
    public static String CONSOLE_TITLE;
    public static String CONSOLE_CHAT_COLOR;

    public static void load(File file) {
        try {
            if (!file.getParentFile().exists())
                file.getParentFile().mkdirs();
            if (!file.exists())
                Main.ExportResource("/config.yml", file);
            YamlConfiguration config = new YamlConfiguration();
            config.load(file);

            // Chat formats
            GLOBAL_CHAT_FORMAT = colorCodes(config.getString("format.global"));
            STAFF_CHAT_FORMAT = colorCodes(config.getString("format.staff"));
            ADMIN_CHAT_FORMAT = colorCodes(config.getString("format.admin"));
            BUILDER_CHAT_FORMAT = colorCodes(config.getString("format.builder"));
            // Console chat settings
            CONSOLE_PREFIX = colorCodes(config.getString("console.prefix"));
            CONSOLE_TITLE = colorCodes(config.getString("console.title"));
            CONSOLE_CHAT_COLOR = colorCodes(config.getString("console.chat-color"));
        } catch (IOException | InvalidConfigurationException e) {
            e.printStackTrace();
        }
    }
}
