package com.tidefactions.chat.Databases;

import com.tidefactions.chat.Types.Prefix;
import org.bukkit.entity.Player;

import java.io.File;
import java.sql.*;

public class PrefixDatabase {

    private static String url;

    public static void init(String path) {
        File dbFile = new File(path + "/playerData.db");
        url = "jdbc:sqlite:" + path + "/playerData.db";
        if (!dbFile.getParentFile().exists())
            dbFile.getParentFile().mkdirs();
        if (!dbFile.exists()) {
            createTable();
        }
    }

    public static void createTable() {
        // SQL statement for creating a new table
        String sql = "CREATE TABLE IF NOT EXISTS prefixes (\n"
                + "	uuid TEXT PRIMARY KEY,\n"
                + "	prefix TEXT NOT NULL\n"
                + ");";

        try (Connection conn = DriverManager.getConnection(url);
             Statement stmt = conn.createStatement()) {
            stmt.execute(sql);
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    public static String getPrefixIDForPlayer(Player player) {
        try (Connection conn = DriverManager.getConnection(url);
             Statement stmt = conn.createStatement()) {
            ResultSet result = stmt.executeQuery("SELECT * FROM prefixes WHERE uuid='" + player.getUniqueId() + "'");
            while (result.next()) {
                return result.getString("prefix");
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return "Default";
    }

    public static void setPrefix(Player player, Prefix prefix) {
        try (Connection conn = DriverManager.getConnection(url);
             Statement stmt = conn.createStatement()) {
            stmt.execute("DELETE FROM prefixes WHERE uuid='" + player.getUniqueId() + "'");
        } catch (SQLException e) {
            e.printStackTrace();
        }

        try (Connection conn = DriverManager.getConnection(url);
             Statement stmt = conn.createStatement()) {
            stmt.execute("INSERT INTO prefixes ('uuid', 'prefix') VALUES ('" + player.getUniqueId() + "', '" + prefix.getName() + "')");
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
}
