package com.tidefactions.chat;

import com.tidefactions.chat.Commands.CommandAdminChat;
import com.tidefactions.chat.Commands.CommandBuilderChat;
import com.tidefactions.chat.Commands.CommandPrefix;
import com.tidefactions.chat.Commands.CommandStaffChat;
import com.tidefactions.chat.Databases.PrefixDatabase;
import com.tidefactions.chat.EventHandlers.ChatHandler;
import com.tidefactions.chat.EventHandlers.InventoryHandler;
import com.tidefactions.chat.Utils.PrefixUtils;
import net.milkbowl.vault.chat.Chat;
import net.milkbowl.vault.permission.Permission;
import org.bukkit.ChatColor;
import org.bukkit.plugin.RegisteredServiceProvider;
import org.bukkit.plugin.java.JavaPlugin;

import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.logging.Logger;

public final class Main extends JavaPlugin {

    public static Logger logger;
    public static Main plugin;

    public static Permission perms = null;
    public static Chat chat = null;


    //TODO list
    //- Save and load current prefix
    //- Announcement support
    //- Titles

    @Override
    public void onEnable() {
        logger = this.getLogger();
        plugin = this;
        setupPermissions();
        PrefixDatabase.init(getDataFolder().getPath());
        Config.load(new File(getDataFolder(), "config.yml"));
        Messages.load(new File(getDataFolder(), "messages.yml"));
        PrefixUtils.loadPrefixes(new File(plugin.getDataFolder(), "prefixes.yml"));
        getServer().getPluginManager().registerEvents(new ChatHandler(), this);
        getServer().getPluginManager().registerEvents(new InventoryHandler(), this);
        getCommand("bc").setExecutor(new CommandBuilderChat());
        getCommand("sc").setExecutor(new CommandStaffChat());
        getCommand("ac").setExecutor(new CommandAdminChat());
        getCommand("prefix").setExecutor(new CommandPrefix());
    }

    @Override
    public void onDisable() {
        // Plugin shutdown logic
    }

    public static void ExportResource(String resourceName, File output) {
        try (InputStream stream = Main.class.getResourceAsStream(resourceName); OutputStream resStreamOut = new FileOutputStream(output)) {
            if (stream == null) {
                throw new Exception("Cannot get resource \"" + resourceName + "\" from Jar file.");
            }

            int readBytes;
            byte[] buffer = new byte[4096];
            while ((readBytes = stream.read(buffer)) > 0) {
                resStreamOut.write(buffer, 0, readBytes);
            }
        } catch (Exception ex) {
            //Fail silently
        }
    }

    public static String colorCodes(String string) {
        return ChatColor.translateAlternateColorCodes('&', string);
    }

    private boolean setupPermissions() {
        RegisteredServiceProvider<Permission> rsp = getServer().getServicesManager().getRegistration(Permission.class);
        perms = rsp.getProvider();
        return perms != null;
    }
}
