package com.tidefactions.chat;

import org.bukkit.configuration.InvalidConfigurationException;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;

import static com.tidefactions.chat.Main.colorCodes;

public class Messages {

    public static String PREFIX;
    public static String NO_PERMISSION;
    public static String AC_CONSOLE;
    public static String AC_TOGGLE_ON;
    public static String AC_TOGGLE_OFF;
    public static String SC_CONSOLE;
    public static String SC_TOGGLE_ON;
    public static String SC_TOGGLE_OFF;
    public static String BC_CONSOLE;
    public static String BC_TOGGLE_ON;
    public static String BC_TOGGLE_OFF;


    public static void load(File file) {
        try {
            if (!file.getParentFile().exists())
                file.getParentFile().mkdirs();
            if (!file.exists())
                Main.ExportResource("/messages.yml", file);
            YamlConfiguration config = new YamlConfiguration();
            config.load(file);

            // Generic
            PREFIX = colorCodes(config.getString("prefix"));
            NO_PERMISSION = colorCodes(config.getString("no-permission"));

            // Ac messages
            AC_CONSOLE = colorCodes(config.getString("ac-console"));
            AC_TOGGLE_ON = colorCodes(config.getString("ac-toggle-on"));
            AC_TOGGLE_OFF = colorCodes(config.getString("ac-toggle-off"));

            // Sc messages
            SC_CONSOLE = colorCodes(config.getString("sc-console"));
            SC_TOGGLE_ON = colorCodes(config.getString("sc-toggle-on"));
            SC_TOGGLE_OFF = colorCodes(config.getString("sc-toggle-off"));

            // Bc messages
            BC_CONSOLE = colorCodes(config.getString("bc-console"));
            BC_TOGGLE_ON = colorCodes(config.getString("bc-toggle-on"));
            BC_TOGGLE_OFF = colorCodes(config.getString("bc-toggle-off"));
        } catch (IOException | InvalidConfigurationException e) {
            e.printStackTrace();
        }
    }
}
